10 REM  1997/9
20 REM     CALCULATE STRESS AND DISPLACEMENT, AND DRAW STRESS
30 REM         ------- I2VDR2 FOR WINDOWS95 -------
40 REM                  BY TAKAYUKI HIRAI
50 DEFSTR G
60 DIM CX(400,2),X(8000,2),F(8000),NEG(30),AP(8000,2),ANG(8000),R(8000)
70 DIM W(8000,4),JBB(30,30),M(8000),Q(5,2,2),JAA(30,30),HH(8000,2),SSG(30)
80 DIM JA(30),JB(30),PRR(30),ENN(30),THH(30),IP(30),QQ(2,8000,2,2)
90 OPEN "R1" FOR INPUT AS #1
92 open "RR" for append as #2
94 print #2,999
96 close #2
98 KILL"RR"
100 OPEN "RR" FOR OUTPUT AS #2
110 PRINT #2," NO.  COORDINATE X, Y,  PRINCIPAL STRESS: NORMAL MAX., MIN., SHEARING,  DIRECRION OF NORMAL MAX.,  NORMAL STRESS X, STRESS Y, SHEARING STRESS XY,  DISPLACEMENT X, DIS. Y" 
120 ZP=3.14159:ZI=1!/ZP
130 CLS
140 PRINT " "
150 PRINT "    CALCULATE STRESS AND DISPLACEMENT, AND OUTPUT IN FILE RR"
160 PRINT "    DRAW STRESS ON POINTS IN A BLOCK"
170 PRINT " ":PRINT " "
180 INPUT "           BLOCK NUMBER =";BLOC
190 PRINT " ":PRINT " "
200 INPUT "           SCALE OF STRESS =";SCS
210 PRINT " ":PRINT " "
220 input #1,GZ:print GZ
222 input #1,GZ:print GZ
224 GM=left$(GZ,11)
226 input #1,GZ:print GZ
228 input #1,GZ:print GZ
230 INPUT #1,GG
240 G1=LEFT$(GG,10):NB=VAL(RIGHT$(G1,3))
242 G1=left$(GG,92):XS=val(right$(G1,12))
244 G1=left$(GG,104):YS=val(right$(G1,12))
246 G1=left$(GG,116):XYS=val(right$(G1,12))
250 INPUT #1,GG
260 FOR J=1 TO NB
270 INPUT #1,GG:INPUT #1,GG:INPUT #1,GG
280 G1=LEFT$(GG,26):NEG(J)=VAL(RIGHT$(G1,3)):N1=NEG(J)
290 G2=left$(GG,54):PRR(J)=val(right$(G2,10))
300 G3=left$(GG,87):ENN(J)=val(right$(G3,15))
310 G4=left$(GG,110):THH(J)=val(right$(G4,11))
320 G5=LEFT$(GG,123):IP(J)=VAL(RIGHT$(G5,4))
330 INPUT #1,GG
340 G1=left$(GG,25):SSG(J)=val(right$(G1,10))
350 INPUT #1,GG
360 FOR II=1 TO N1
370 L1=47+5*II:G1=LEFT$(GG,L1):JBB(J,II)=VAL(RIGHT$(G1,5))
380 NEXT II:NEXT J
390 IT=0:JAA(1,1)=1:JA(1)=1
400 FOR J8=1 TO NB
410 N1=NEG(J8):JB(J8)=JBB(J8,N1)
420 IF J8=1 THEN GOTO 440
430 JA(J8)=JB(J8-1)+1:JAA(J8,1)=JA(J8)
440 FOR J9=2 TO N1
450 JAA(J8,J9)=JBB(J8,J9-1)+1:NEXT J9
460 FOR J9=1 TO N1
470 NE1=JAA(J8,J9):NE2=JBB(J8,J9)
480 FOR I=1 TO 3:INPUT #1,GG:NEXT I
490 FOR I=NE1 TO NE2
500 INPUT #1,K1,K2,K3,K4,X1,X2,N1,N2,N3,N4,R5,F1
510 IT=IT+1:X(2*IT-1,1)=X1:X(2*IT,1)=X2:R(IT)=R5/2
520 F(IT)=F1*ZP/180:M(IT)=K1
530 IF I=NE1 THEN GOTO 550
540 X(2*(IT-1)-1,2)=X1:X(2*(IT-1),2)=X2:GOTO 560
550 X(2*NE2-1,2)=X1:X(2*NE2,2)=X2
560 NEXT I:NEXT J9:NEXT J8
570 INPUT #1,GG:INPUT #1,GG
580 II=FIX(IT/2+.6):IIX=II*2-IT
590 IF IIX=0 THEN IIM=II
600 IF IIX=1 THEN IIM=II-1
610 FOR I=1 TO IIM
620 INPUT #1,N1,X1,X2,X3,X4,N2,X5,X6,X7,X8
630 W(N1,1)=X1:W(N1,2)=X2:W(N1,3)=X3:W(N1,4)=X4
640 W(N2,1)=X5:W(N2,2)=X6:W(N2,3)=X7:W(N2,4)=X8
650 NEXT I
660 IF IIX=0 THEN GOTO 690
670 INPUT #1,N1,X1,X2,X3,X4
680 W(N1,1)=X1:W(N1,2)=X2:W(N1,3)=X3:W(N1,4)=X4
690 FOR I=1 TO 4:INPUT #1,GG:NEXT I
700 FOR I=1 TO IT
710 INPUT #1,K1,K2,K3,K4,K5,K6,T1,T2,T3,T4,D1,D2,D3,D4
720 AP(I,1)=K5:AP(I,2)=K6:NEXT I
730 REM
740 REM ------ INPUT COORDINATE OF POINT ------
750 PRINT "  CHOOSE THE WAY OF INPUTTING POINT COORDINATE,"
760 PRINT "       FILE D1                       WAY = 1"
770 PRINT "       KEY BOARD, EACH POINT         WAY = 2"
780 PRINT "       KEY BOARD, POINTS ON A LINE   WAY = 3"
790 PRINT "       KEY BOARD, POINTS ON A MESH   WAY = 4"
800 PRINT " ":INPUT "             WAY =";WAY
810 PRINT " ":PRINT " "
820 IF WAY=4 THEN GOTO 1140
830 IF WAY=3 THEN GOTO 1030
840 IF WAY=2 THEN GOTO 930
850 CLS 
855 PRINT " ":PRINT " ":PRINT " ":PRINT " "
860 PRINT "   INPUT COORDINATE FROM FILE D1 "
870 PRINT "       FIRST DATA IN END LINE OF FILE D1 MUST BE 99999"
880 CLOSE #1
890 OPEN "D1" FOR INPUT AS #1
900 FOR I=1 TO 400:INPUT #1,I3
910 IF I3>90000! THEN GOTO 1260
912 INPUT #1,CX(I,1),CX(I,2)
920 I9=I:NEXT I
930 PRINT " ":I9=0
940 CLS
945 PRINT " ":PRINT " ":PRINT " ":PRINT " "
950 PRINT "   INPUT COORDINATE OF EACH POINT"
960 PRINT " ":PRINT "         END X-COORDINATE = 99999"
970 PRINT " "
980 INPUT "             X-COORDINATE =",X3
990 IF X3>90000! THEN GOTO 1260
1000 I9=I9+1:CX(I9,1)=X3
1010 INPUT "             Y-COORDINATE =",CX(I9,2)
1020 GOTO 940
1030 CLS
1035 PRINT " ":PRINT " ":PRINT " ":PRINT " "
1040 PRINT "   INPUT COORDINATE OF LINE END, AND DIVIDE NUMBER"
1050 PRINT " ":INPUT " LINE END X-COORDINATE =";XL
1060 INPUT " LINE END Y-COORDINATE =";YL
1070 INPUT " ANOTHER LINE END X-COORDINATE =";XR
1080 INPUT " ANOTHER LINE END Y-COORDINATE =";YR
1090 PRINT " ":INPUT "   DIVIDE NUMBER =";TX
1100 XV=(XR-XL)/TX:YV=(YR-YL)/TX:I9=TX+1
1110 FOR I=1 TO I9:CX(I,1)=XL+XV*(I-1)
1120 CX(I,2)=YL+YV*(I-1):NEXT I
1130 GOTO 1260
1140 CLS
1145 PRINT " ":PRINT " ":PRINT " ":PRINT " "
1150 PRINT "   INPUT COORDINATE OF MESH VERTEX, AND DIVIDE NUMBER"
1160 PRINT " ":INPUT " VERTEX X-COORDINATE =";XL
1170 INPUT " VERTEX Y-COORDINATE =";YL
1180 INPUT " OPPOSITE VERTEX X-COORDINATE =";XR
1190 INPUT " OPPOSITE VERTEX Y-COORDINATE =";YR
1200 PRINT" ":INPUT "    DIVIDE NUMBER OF X-DIRECTION =";MX
1210 INPUT "    DIVIDE NUMBER OF Y-DIRECTION =";MY
1220 MX1=MX+1:MY1=MY+1:I9=MX1*MY1:X2=(XR-XL)/MX:Y2=(YR-YL)/MY:I9=0
1230 FOR I=1 TO MX1:FOR J=1 TO MY1:I9=I9+1
1240 CX(I9,1)=XL+X2*(I-1):CX(I9,2)=YL+Y2*(J-1)
1250 NEXT J:NEXT I
1260 REM 
1270 REM ------ CALCULATE STRESS AND DEFORMATION ------
1280 PR=PRR(BLOC):EN=ENN(BLOC):TH=THH(BLOC):KA=JA(BLOC):KB=JB(BLOC)
1290 IF IP(BLOC)=1 THEN EN=EN/(1-PR*PR)
1300 IF IP(BLOC)=1 THEN PR=PR/(1-PR)
1310 PRINT " "
1320 FOR I=1 TO I9
1330 PRINT "  CALCULATING POINT NUMBER =";I
1340 QS1=0:QS2=0:QS3=0:QS4=0:QS5=0
1350 FOR J=KA TO KB
1360 LF=J:SF=SIN(F(J)):CF=COS(F(J))
1370 UU= (CX(I,1)-AP(J,1))*CF+(CX(I,2)-AP(J,2))*SF
1380 VV=-(CX(I,1)-AP(J,1))*SF+(CX(I,2)-AP(J,2))*CF
1390 IF M(J)=1 THEN UU=UU-R(J)
1400 IF M(J)=4 THEN UU=UU-R(J)
1410 IF M(J)=2 THEN UU=UU+R(J)
1420 IF M(J)=5 THEN UU=UU+R(J)
1430 FOR J2=1 TO 5:FOR J3=1 TO 2:FOR J4=1 TO 2
1440 Q(J2,J3,J4)=0!:NEXT J4:NEXT J3:NEXT J2
1450 PQ=1!-PR:PS=1!+PR:T=R(LF)*2!
1460 IF M(LF)=0 THEN T=R(LF)
1470 IF M(LF)=3 THEN T=R(LF)
1480 UA=UU-T:UB=UU+T:RR=SQR(UU*UU+VV*VV)
1490 WM=(3!+PR)*.25*ZI:WN=(1!-PR)*.25*ZI
1500 WA=(PR-3!)*(PR+1!)*.25*ZI/EN:WB=(PR+1!)*(PR+1!)*.25*ZI/EN
1510 IF ABS(VV)>.0005*T THEN GOTO 2010
1520 IF ABS(ABS(UU)-T)<.0005*T THEN GOTO 2000
1530 BBB=LOG(ABS(UB/UA))
1540 IF M(LF)>2 THEN GOTO 1680
1550 Q(1,1,1)=-WM*(1!-BBB*UA*.5/T)
1560 Q(1,1,2)= WM*(1!-BBB*UB*.5/T)
1570 Q(2,1,1)= WN*(1!-BBB*UA*.5/T)
1580 Q(2,1,2)=-WN*(1!-BBB*UB*.5/T)
1590 Q(3,2,1)= WN*(1!-BBB*UA*.5/T)
1600 Q(3,2,2)=-WN*(1!-BBB*UB*.5/T)
1610 IF ABS(UU)<T THEN Q(3,1,1)=UA*.25/T
1620 IF ABS(UU)<T THEN Q(3,1,2)=-UB*.25/T
1630 IF ABS(UU)<T THEN Q(1,2,1)=-UA*PR*.25/T
1640 IF ABS(UU)<T THEN Q(1,2,2)= UB*PR*.25/T
1650 IF ABS(UU)<T THEN Q(2,2,1)=-UA*.25/T
1660 IF ABS(UU)<T THEN Q(2,2,2)= UB*.25/T
1670 GOTO 1760
1680 Q(1,1,1)=ZI*(-2!+(UA/T)*BBB)
1690 Q(1,1,2)=ZI*(2!-(UB/T)*BBB)
1700 IF ABS(UU)<T THEN Q(2,2,1)=.5*(-UA/T)
1710 IF ABS(UU)<T THEN Q(2,2,2)=.5*(UB/T)
1720 IF ABS(UU)<T THEN Q(3,1,1)=.5*(UA/T)
1730 IF ABS(UU)<T THEN Q(3,1,2)=.5*(-UB/T)
1740 IF ABS(UU)<T THEN Q(1,2,1)=.5*(-UA/T)
1750 IF ABS(UU)<T THEN Q(1,2,2)=.5*(UB/T)
1760 QQQ=UA*LOG(ABS(UA))-UB*LOG(ABS(UB))
1770 WWW=UA*UA*LOG(ABS(UA))-UB*UB*LOG(ABS(UB))
1780 IF M(LF)>2 GOTO 1840
1790 Q(4,1,1)=(-(.5*WA*WWW+(WA-2!*WB)*UU*T)+UA*(WA*QQQ+(WA-WB)*2!*T))*.5/T
1800 Q(4,1,2)=( (.5*WA*WWW+(WA-2!*WB)*UU*T)-UB*(WA*QQQ+(WA-WB)*2!*T))*.5/T
1810 Q(5,2,1)= WA*(-.5*WWW/T-UU+(QQQ/T+2!)*UA)*.5
1820 Q(5,2,2)=-WA*(-.5*WWW/T-UU+(QQQ/T+2!)*UB)*.5
1830 GOTO 2680
1840 WX=.5*ZI/EN/T
1850 Q(4,1,1)= WX*(-2!*(QQQ+2!*T)*UA+WWW+2!*UU*T)
1860 Q(4,1,2)=-WX*(-2!*(QQQ+2!*T)*UB+WWW+2!*UU*T)
1870 Q(5,2,1)= WX*(-2!*(QQQ+PQ*T)*UA+WWW-2!*UU*T*PR)
1880 Q(5,2,2)=-WX*(-2!*(QQQ+PQ*T)*UB+WWW-2!*UU*T*PR)
1890 WD=-ZP*UU
1900 WV=-ZP*(UU*UU+T*T)
1910 if UU>T then WD=-ZP*T
1920 if UU>T then WV=-2!*ZP*UU*T
1930 if UU<-T then WD=ZP*T
1940 if UU<-T then WV=2!*ZP*UU*T
1950 Q(5,1,1)= WX*PQ*(-WD*UA+.5*WV)
1960 Q(5,1,2)=-WX*PQ*(-WD*UB+.5*WV)
1970 Q(4,2,1)= WX*PQ*(WD*UA-.5*WV)
1980 Q(4,2,2)=-WX*PQ*(WD*UB-.5*WV)
1990 GOTO 2680
2000 VV=-.0005*T
2010 UU=UU+T
2020 IF UU=0 THEN GOTO 2060
2030 FA=ATN(VV/UU):IF UU>0 THEN GOTO 2080
2040 FA=FA+ZP:IF VV<0 THEN FA=FA-ZP*2!
2050 GOTO 2080
2060 FA=ZP*.5:IF VV<0 THEN FA=FA-ZP
2070 IF VV=0 THEN FA=0!
2080 UU=UU-2!*T
2090 IF UU=0 THEN GOTO 2130
2100 FB=ATN(VV/UU):IF UU>0 THEN GOTO 2150
2110 FB=FB+ZP:IF VV<0 THEN FB=FB-ZP*2!
2120 GOTO 2150
2130 FB=ZP*.5:IF VV<0 THEN FB=FB-ZP
2140 IF VV=0 THEN FB=0!
2150 FBA=FB-FA:SA=SIN(FA):SB=SIN(FB)
2160 SSS=SIN(2!*FB)-SIN(2!*FA):CCC=COS(2!*FB)-COS(2!*FA)
2170 AAA=LOG(ABS(SB/SA)):TTT=1!/TAN(FB)-1!/TAN(FA)
2180 IF M(LF)>2 THEN GOTO 2330
2190 W4=.25*(WM-WN):W2=.5*(WM+WN)
2200 Q(1,1,1)=((WM*TTT+(1.5*WM-.5*WN)*FBA+W4*SSS)*VV+(WM*AAA+W4*CCC)*UA)*.5/T
2210 Q(1,1,2)=(-(WM*TTT+(1.5*WM-.5*WN)*FBA+W4*SSS)*VV-(WM*AAA+W4*CCC)*UB)*.5/T
2220 Q(2,1,1)=(-(WN*TTT+W2*FBA+W4*SSS)*VV-(WN*AAA+W4*CCC)*UA)*.5/T
2230 Q(2,1,2)=( (WN*TTT+W2*FBA+W4*SSS)*VV+(WN*AAA+W4*CCC)*UB)*.5/T
2240 Q(3,1,1)=( (WM*AAA+W4*CCC)*VV-(W2*FBA+W4*SSS)*UA)*.5/T
2250 Q(3,1,2)=(-(WM*AAA+W4*CCC)*VV+(W2*FBA+W4*SSS)*UB)*.5/T
2260 Q(1,2,1)=(((-WM+2!*WN)*AAA-W4*CCC)*VV+((.5*WM-1.5*WN)*FBA+W4*SSS)*UA)*.5/T
2270 Q(1,2,2)=(-((-WM+2!*WN)*AAA-W4*CCC)*VV-((.5*WM-1.5*WN)*FBA+W4*SSS)*UB)*.5/T
2280 Q(2,2,1)=( (-WN*AAA+W4*CCC)*VV+(W2*FBA-W4*SSS)*UA)*.5/T
2290 Q(2,2,2)=(-(-WN*AAA+W4*CCC)*VV-(W2*FBA-W4*SSS)*UB)*.5/T
2300 Q(3,2,1)=((-WN*TTT+(.5*WM-1.5*WN)*FBA+W4*SSS)*VV-(WN*AAA-W4*CCC)*UA)*.5/T
2310 Q(3,2,2)=(-(-WN*TTT+(.5*WM-1.5*WN)*FBA+W4*SSS)*VV+(WN*AAA-W4*CCC)*UB)*.5/T
2320 GOTO 2450
2330 Q(1,1,1)=ZI*(UA/T*(AAA+.25*CCC)+VV/T*(1.5*FBA+.25*SSS+TTT))
2340 Q(1,1,2)=ZI*(-UB/T*(AAA+.25*CCC)-VV/T*(1.5*FBA+.25*SSS+TTT))
2350 Q(2,1,1)=ZI*(-.25*UA/T*CCC-.5*VV/T*(FBA+.5*SSS))
2360 Q(2,1,2)=ZI*(.25*UB/T*CCC+.5*VV/T*(FBA+.5*SSS))
2370 Q(3,1,1)=ZI*(-.5*UA/T*(FBA+.5*SSS)+VV/T*(.25*CCC+AAA))
2380 Q(3,1,2)=ZI*(.5*UB/T*(FBA+.5*SSS)-VV/T*(.25*CCC+AAA))
2390 Q(1,2,1)=ZI/T*(.5*UA*(FBA+.5*SSS)-VV*(AAA+.25*CCC))
2400 Q(1,2,2)=ZI/T*(-.5*UB*(FBA+.5*SSS)+VV*(AAA+.25*CCC))
2410 Q(2,2,1)=ZI/T*(.5*UA*(FBA-.5*SSS)+.25*VV*CCC)
2420 Q(2,2,2)=-ZI/T*(.5*UB*(FBA-.5*SSS)+.25*VV*CCC)
2430 Q(3,2,1)=ZI/T*(.5*VV*(FBA+.5*SSS)+.25*UA*CCC)
2440 Q(3,2,2)=-ZI/T*(.5*VV*(FBA+.5*SSS)+.25*UB*CCC)
2450 FGG=LOG(ABS(SB/VV))/SB/SB-LOG(ABS(SA/VV))/SA/SA
2460 HHH=1!/SB/SB-1!/SA/SA
2470 EEE=1!/TAN(FB)*LOG(ABS(SB/VV))-1!/TAN(FA)*LOG(ABS(SA/VV))
2480 IF M(LF)>2 THEN GOTO 2580
2490 Q(4,1,1)=( (WA*(.5*FGG+.25*HHH)-WB*(AAA+.5*HHH))*VV-(WA*EEE+(WA-WB)*(TTT+FBA))*UA)*.5*VV/T
2500 Q(4,1,2)=(-(WA*(.5*FGG+.25*HHH)-WB*(AAA+.5*HHH))*VV+(WA*EEE+(WA-WB)*(TTT+FBA))*UB)*.5*VV/T
2510 Q(5,1,1)=(-(TTT+FBA)*VV-AAA*UA)*WB*.5*VV/T
2520 Q(5,1,2)=( (TTT+FBA)*VV+AAA*UB)*WB*.5*VV/T
2530 Q(4,2,1)=Q(5,1,1)
2540 Q(4,2,2)=Q(5,1,2)
2550 Q(5,2,1)=( (.5*WA*FGG+.25*WA*HHH+WB*AAA)*VV-(WA*(EEE+TTT)+(WA+WB)*FBA)*UA)*VV*.5/T
2560 Q(5,2,2)=(-(.5*WA*FGG+.25*WA*HHH+WB*AAA)*VV+(WA*(EEE+TTT)+(WA+WB)*FBA)*UB)*VV*.5/T
2570 GOTO 2680
2580 VVV=(FB+.5*ZP)/SB/SB-(FA+.5*ZP)/SA/SA
2590 DDD=(FB+.5*ZP)/TAN(FB)-(FA+.5*ZP)/TAN(FA)
2600 Q(4,1,1)=VV*ZI/EN*(-.5*VV/T*(FGG+.5*HHH+PS*AAA)+UA/T*(EEE+TTT+.5*(3!+PR)*FBA))
2610 Q(4,1,2)=VV*ZI/EN*(.5*VV/T*(FGG+.5*HHH+PS*AAA)-UB/T*(EEE+TTT+.5*(3!+PR)*FBA))
2620 Q(5,1,1)=VV*ZI/EN*(-UA/T*(PQ*DDD+2!*PR*AAA)+VV/T*(.5*PQ*VVV-PS*FBA-.5*(1!+3!*PR)*TTT))*.5
2630 Q(5,1,2)=VV*ZI/EN*(UB/T*(PQ*DDD+2!*PR*AAA)-VV/T*(.5*PQ*VVV-PS*FBA-.5*(1!+3!*PR)*TTT))*.5
2640 Q(4,2,1)=.5*ZI*VV/EN*(-UA/T*(-PQ*DDD+2!*AAA)-VV/T*(.5*PQ*VVV+PS*FBA+.5*(3!+PR)*TTT))
2650 Q(4,2,2)=.5*ZI*VV/EN*(UB/T*(-PQ*DDD+2!*AAA)+VV/T*(.5*PQ*VVV+PS*FBA+.5*(3!+PR)*TTT))
2660 Q(5,2,1)=ZI*VV/EN*(-.5*VV/T*(FGG-.5*PR*HHH-PS*AAA)+UA/T*(EEE+.5*PQ*(TTT+FBA)))
2670 Q(5,2,2)=ZI*VV/EN*(.5*VV/T*(FGG-.5*PR*HHH-PS*AAA)-UB/T*(EEE+.5*PQ*(TTT+FBA)))
2680 REM
2690 REM ----- CALCULATE STRESS -----
2700 SW=SIN(F(J)):CW=COS(F(J)):SS=SW*SW:CC=CW*CW
2710 SSW=2*SW*CW:CCW=2*CC-1
2720 FOR KP=1 TO 2:FOR KQ=1 TO 2
2730 WX=Q(1,KP,KQ)*CC+Q(2,KP,KQ)*SS+Q(3,KP,KQ)*SSW
2740 WY=Q(1,KP,KQ)*SS+Q(2,KP,KQ)*CC-Q(3,KP,KQ)*SSW
2750 WXY=.5*(Q(1,KP,KQ)-Q(2,KP,KQ))*SSW-Q(3,KP,KQ)*CCW
2760 DX=Q(4,KP,KQ)*CW-Q(5,KP,KQ)*SW
2770 DY=Q(4,KP,KQ)*SW+Q(5,KP,KQ)*CW
2780 KK=KP*2-2+KQ
2790 QS1=QS1+WX*W(J,KK)
2800 QS2=QS2+WY*W(J,KK)
2810 QS3=QS3+WXY*W(J,KK)
2820 QS4=QS4+DX*W(J,KK)
2830 QS5=QS5+DY*W(J,KK)
2840 NEXT KQ:NEXT KP
2850 NEXT J
2856 QS1=QS1/TH+XS:QS2=QS2/TH+YS:QS3=QS3/TH+XYS
2864 EX=(XS-PR*YS)/EN
2866 EY=(YS-PR*XS)/EN
2868 EXY=XYS*2.0*(1.0+PR)/EN
2870 QS4=(QS4+EX*CX(I,1)+EXY*CX(I,2))/TH
2872 QS5=(QS5+EY*CX(I,2))/TH
2874 S4=SSG(BLOC)*EN/(1!-PR)
2876 QS1=QS1-S4:QS2=QS2-S4
2880 UU=(QS1-QS2)/2
2890 VV=-QS3:H3=SQR(UU*UU+VV*VV)
2900 H1=(QS1+QS2)/2+H3:H2=(QS1+QS2)/2-H3
2910 IF UU=0 THEN GOTO 2950
2920 FUV=ATN(VV/UU):IF UU>0 THEN GOTO 2970
2930 FUV=FUV+ZP:IF VV<0 THEN FUV=FUV-ZP*2!
2940 GOTO 2970
2950 FUV=ZP*.5:IF VV<0 THEN FUV=FUV-ZP
2960 IF VV=0 THEN FUV=0!
2970 ANG(I)=-FUV/2:ANGLE=-FUV*90*ZI
2980 PRINT #2,I,CX(I,1),CX(I,2),H1,H2,H3,ANGLE,QS1,QS2,QS3,QS4,QS5
2990 PRINT I,CX(I,1),CX(I,2),H1,H2,H3,ANGLE,QS1,QS2,QS3,QS4,QS5
3000 HH(I,1)=H1:HH(I,2)=H2
3010 SF=SIN(ANG(I))*SCS:CF=COS(ANG(I))*SCS
3020 QQ(1,I,1,1)=CX(I,1)-H1*CF:QQ(1,I,1,2)=CX(I,2)-H1*SF
3030 QQ(1,I,2,1)=CX(I,1)+H1*CF:QQ(1,I,2,2)=CX(I,2)+H1*SF
3040 SF=SIN(ANG(I)+ZP/2)*SCS:CF=COS(ANG(I)+ZP/2)*SCS
3050 QQ(2,I,1,1)=CX(I,1)-H2*CF:QQ(2,I,1,2)=CX(I,2)-H2*SF
3060 QQ(2,I,2,1)=CX(I,1)+H2*CF:QQ(2,I,2,2)=CX(I,2)+H2*SF
3070 NEXT I
3080 REM
3090 REM ----- SCALING -----
3100 XA=999999!:XB=-999999!:YA=999999!:YB=-999999!
3110 FOR I=1 TO I9:FOR J=1 TO 2:FOR K=1 TO 2
3120 IF QQ(J,I,K,1)<XA THEN XA=QQ(J,I,K,1)
3130 IF QQ(J,I,K,1)>XB THEN XB=QQ(J,I,K,1)
3140 IF QQ(J,I,K,2)<YA THEN YA=QQ(J,I,K,2)
3150 IF QQ(J,I,K,2)>YB THEN YB=QQ(J,I,K,2)
3160 NEXT K:NEXT J:NEXT I
3170 XM=XB-XA:YM=YB-YA
3180 TRA=160/YM
3190 IF XM*4>YM*6 THEN TRA=250/XM
3192 REM
3194 REM  ------ DRAW PRE-DEFORMATION ------
3196 #include"WINDOWS.BI"
3198 var FORM as object
3200 var BITMAP1 as object
3202 SETMAPMODE 1
3204 SETREDRAWMODE 1
3206 FORM.ATTACH GETHWND
3208 BITMAPOBJECT BITMAP1
3210 view (0,0)-(636,433)
3212 window (0,-3)-(620,210)
3214 color 0,15
3216 CLS 
3218 SSSS=8/TRA/SCS
3220 PRINT"      RED TENSION, GREEN COMPRESSION, SCALE=";SSSS;"    ";GM
3250 N8=1:N9=NB:IF BLOC=0 THEN GOTO 3270
3260 N8=BLOC:N9=BLOC
3270 FOR J8=N8 TO N9
3280 N1=NEG(J8)
3290 FOR J9=1 TO N1
3300 NE1=JAA(J8,J9):NE2=JBB(J8,J9)
3310 FOR I=NE1 TO NE2
3320 XL=CINT((X(2*I-1,1)-XA)*TRA*2+10)
3330 XR=CINT((X(2*I-1,2)-XA)*TRA*2+10)
3340 YL=CINT(190-(X(2*I,1)-YA)*TRA)
3350 YR=CINT(190-(X(2*I,2)-YA)*TRA)
3360 IF I>NE1 THEN F4=(F(I-1)+F(I)+ZP)/2
3370 IF I=NE1 THEN F4=(F(NE2)+F(NE1)+ZP)/2
3380 A1=COS(F4)*2
3390 A2=SIN(F4)*1
3400 B1=XL+A1:B2=YL-A2:C1=XL-A1:C2=YL+A2
3410 LINE (XL,YL)-(XR,YR),PSET,0:LINE (B1,B2)-(C1,C2),PSET,0
3420 NEXT I:NEXT J9:NEXT J8
3430 REM
3440 REM ------ DRAW STRESS ------
3450 FOR I=1 TO I9:FOR J=1 TO 2
3460 XL=CINT((QQ(J,I,1,1)-XA)*TRA*2+10)
3470 XR=CINT((QQ(J,I,2,1)-XA)*TRA*2+10)
3480 YL=CINT(190-(QQ(J,I,1,2)-YA)*TRA)
3490 YR=CINT(190-(QQ(J,I,2,2)-YA)*TRA)
3500 K4=5:IF HH(I,J)<0 THEN K4=8
3510 LINE(XL,YL)-(XR,YR),PSET,K4
3520 IF J=2 THEN GOTO 3760
3530 S1=SIN(ANG(I)+ZP/4)*3:C1=COS(ANG(I)+ZP/4)*6
3540 S2=SIN(ANG(I)-ZP/4)*3:C2=COS(ANG(I)-ZP/4)*6
3550 IF HH(I,1)<0 THEN GOTO 3690
3560 IF XL>XR THEN GOTO 3590
3570 XL1=XL+C1:XL2=XL+C2
3580 XR1=XR-C1:XR2=XR-C2:GOTO 3610
3590 XL1=XL-C1:XL2=XL-C2
3600 XR1=XR+C1:XR2=XR+C2
3610 REM IF YL>YR THEN GOTO 3580
3620 YL1=YL-S1:YL2=YL-S2
3630 YR1=YR+S1:YR2=YR+S2:GOTO 3660
3640 YL1=YL+S1:YL2=YL+S2
3650 YR1=YR-S1:YR2=YR-S2
3660 LINE(XL,YL)-(XL1,YL1),PSET,3:LINE(XL,YL)-(XL2,YL2),PSET,3
3670 LINE(XR,YR)-(XR1,YR1),PSET,3:LINE(XR,YR)-(XR2,YR2),PSET,3
3680 GOTO 3980
3690 XL1=(XL+XR)/2-C1:XL2=(XL+XR)/2-C2
3700 YL1=(YL+YR)/2+S1:YL2=(YL+YR)/2+S2
3710 XR1=(XL+XR)/2+C1:XR2=(XL+XR)/2+C2
3720 YR1=(YL+YR)/2-S1:YR2=(YL+YR)/2-S2
3730 LINE(XL1,YL1)-(XR1,YR1),PSET,3
3740 LINE(XL2,YL2)-(XR2,YR2),PSET,3
3750 GOTO 3980
3760 S1=SIN(ANG(I)+3*ZP/4)*3:C1=COS(ANG(I)+3*ZP/4)*6
3770 S2=SIN(ANG(I)+ZP/4)*3:C2=COS(ANG(I)+ZP/4)*6
3780 IF HH(I,2)<0 THEN GOTO 3920
3790 REM IF XL>XR THEN GOTO 3760
3800 XL1=XL+C1:XL2=XL+C2
3810 XR1=XR-C1:XR2=XR-C2:GOTO 3840
3820 XL1=XL-C1:XL2=XL-C2
3830 XR1=XR+C1:XR2=XR+C2
3840 REM IF YL>YR THEN GOTO 3810
3850 YL1=YL-S1:YL2=YL-S2
3860 YR1=YR+S1:YR2=YR+S2:GOTO 3890
3870 YL1=YL+S1:YL2=YL+S2
3880 YR1=YR-S1:YR2=YR-S2
3890 LINE(XL,YL)-(XL1,YL1),PSET,3:LINE(XL,YL)-(XL2,YL2),PSET,3
3900 LINE(XR,YR)-(XR1,YR1),PSET,3:LINE(XR,YR)-(XR2,YR2),PSET,3
3910 GOTO 3980
3920 XL1=(XL+XR)/2-C1:XL2=(XL+XR)/2-C2
3930 YL1=(YL+YR)/2+S1:YL2=(YL+YR)/2+S2
3940 XR1=(XL+XR)/2+C1:XR2=(XL+XR)/2+C2
3950 YR1=(YL+YR)/2-S1:YR2=(YL+YR)/2-S2
3960 LINE(XL1,YL1)-(XR1,YR1),PSET,3
3970 LINE(XL2,YL2)-(XR2,YR2),PSET,3
3980 NEXT J:NEXT I
3990 LINE(5,6)-(21,6),PSET,5:LINE(5,6)-(5,-2),PSET,8
4002 BITMAP1.CREATEBITMAP 636,433
4004 BITMAP1.BITBLT 0,0,636,433,FORM,0,-3
4006 BITMAP1.SAVEFILE"AAA.BMP"
4008 BITMAP1.DELETEOBJECT
4010 cls
4012 BITMAP1.LOADFILE"AAA.BMP"
4014 FORM.BITBLT 0,-3,636,433,BITMAP1,0,0
4020 FOR I8=1 TO 9000
4030 WAIT 10
4040 G4=INKEY$
4050 if G4="Q" then goto 4100
4060 if G4="q" then goto 4100
4070 if G4="S" then goto 4100
4080 if G4="s" then goto 4100
4090 NEXT I8
4100 END
   